/***********************************************************************
 *   IRCDSERV - Internet Relay Chat Services                            *
 *   Copyright (C) 1999-2000 Jan Oravec(WSX) and Juraj Lutter(otis)     *
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 1,    *
 *   or (at your option) any later version.                             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 *   You should have received a copy of the GNU General Public License  *
 *   along with this program; if not, write to the Free Software        *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.          *
  ***********************************************************************/

#ifndef _CONFIG_H
#define _CONFIG_H
                 
/* DIRECTORY SECTION
 * DPATH,SPATH,CPATH,MPATH,LPATH - directory and files locations
 *
 * Please note that these are only the recommended names and paths.
 * Change as needed. DPATH is directory name, others are file names.
 *
 * DPATH = services directory,
 * SPATH = services executable,
 * CPATH = conf file,
 * MPATH = MOTD file,
 * LPATH = LOG file,
 * PPATH = PID file
 */

#define DPATH	"/usr/local/ircd/ircdserv1b11"
#define SPATH	"ircdserv"
#define CPATH	"ircdserv.conf"
#define MPATH	"ircdserv.motd"
#define LPATH	"ircdserv.log"
#define PPATH	"ircdserv.pid"

/* TS_MAX_DELTA - allowed delta for TS when another server connects.
 *
 * If the difference between my clock and the other server's clock is
 * greater than TS_MAX_DELTA, I send out a warning and drop the links.
 */

#define TS_MAX_DELTA	60	/* 60 seconds is enought */
 
/* CRYPT_OPER_PASSWORD - use crypted oper passwords in the ircdserv.conf
 * Define this if you want to use crypted passwords for operators in your
 * ircdserv.conf file.
 */

#define CRYPT_OPER_PASSWORD

/* MAXIMUM_LINKS - max configured C:'s in ircdserv.conf
 */

#define	MAXIMUM_LINKS	10

/* LOG_OP - log mode change +o requests
 */

#define	LOG_OP

/* LOG_MODE - log mode change requests
 */

#define LOG_MODE

/* LOG_KICK - log channel kick requests
 */

#define LOG_KICK

/* LOG_KILL - log kill requests
 */

#define LOG_KILL

/* LOG_SQUIT - log squit requests
 */

#define LOG_SQUIT

/* STOP_ABUSERS - stop abusive operators/servers, stop desynching channels
   TOLERATED_SERVER_DELTA_TS - how much seconds after server join can server
                               change modes on channels?
 */

#define STOP_ABUSERS

#ifdef STOP_ABUSERS
#define TOLERATED_SERVER_DELTA_TS	30; // 300 is recommended for EFNET
#endif /* STOP_ABUSERS */

/*  STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP STOP  */

#ifdef LOG_MODE
#define LOG_OP
#endif /* LOG_MODE */

#endif /* _CONFIG_H */
