/***********************************************************************
 *   IRCDSERV - Internet Relay Chat Services                            *
 *   Copyright (C) 1999-2000 Jan Oravec(WSX) and Juraj Lutter(otis)     *
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 1,    *
 *   or (at your option) any later version.                             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 *   You should have received a copy of the GNU General Public License  *
 *   along with this program; if not, write to the Free Software        *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.          *
  ***********************************************************************/
#include "ircdserv.h"

void hh_stats(void)
 {
  TConn *conntmp;
  TOper *opertmp;
  TUser *user;
  TChanList *chanlist;
  char c[PERMNO+1], buff[1024], d[1024];
  int i,j;
  int t;
  
  context;
  user=finduser(who);
// co ked !user ??? treba poslat kill
  switch(whom[0])
   {
    case 'c': case 'C':
     {
      for(conntmp=config.conns;conntmp;conntmp=conntmp->next)
       sockprintf(upFD, ":%s 213 %s C %s * %s %d %d\n", config.name, who, conntmp->host, conntmp->name, conntmp->port, conntmp->wildcarding);
      break;
     }
    case 'o': case 'O':
     {
      for(opertmp=config.opers;opertmp;opertmp=opertmp->next)
       {
        for(i=0,j=0;i!=PERMNO;i++) if(opertmp->perms[i]) c[j++]=65+i; c[j]=0;
        if(opertmp->lognick) strcpy(buff, opertmp->lognick->nick); else strcpy(buff,"*\000");
        d[0]=0;
        for(chanlist=opertmp->chanlist;chanlist;chanlist=chanlist->next)
         sprintf(d, "%s%s,", d, chanlist->channel);
        d[strlen(d)-1]=0;
        if(user->ircop)
          sockprintf(upFD, ":%s 243 %s O %s %s %s %s %s\n", config.name, who, opertmp->host, buff, opertmp->nick, c, d); else
          sockprintf(upFD, ":%s 243 %s O %s * %s * *\n", config.name, who, opertmp->host, opertmp->nick);
       }
      break;
     }
    case 'u':
     {
      t=time(NULL)-info.servicestart;
      sockprintf(upFD, ":%s 242 %s :Services Up %d days, %d:%02d:%02d\n", config.name, who, t/86400, (t%86400)/3600, (t%3600)/60, t%60);
      break;
     }
    case '?':
     {
      break;
     }
   }
  context;
  sockprintf(upFD, ":%s 219 %s %c :End of /STATS report\n", config.name, who, whom[0]);
 }

void hh_privmsg(void)
 {
  int i=0;
  TOper *oper;
  
  context;
  oper=findcnoper(who);
  while(commands[i].cmd)
   {
    if(!strcasecmp(arg[0], commands[i].cmd))
     {
      if((commands[i].perm<0) || (commands[i].perm==32767))
       {
        if(!commands[i].handler()) return;
       } else
       {
        if(oper && oper->perms[commands[i].perm])
         {
          if(!commands[i].handler()) return;
         } else
         {
          usernotice(who, "Permission denied.");
          return;
         }
       }
     }
    i++;
   }
  context;
  usernotice(who, "No such command - %s.", arg[0]);
 }

void hh_notice(void)
 {
  context;
  if(who) hh_privmsg();
 }

void hh_kill(void)
 {
  TUser *user;
  
  context;
  info.kills++;
  user=finduser(whom);
  if(!user)
   {
    logit("HH_KILL: No such nick %s.\n",whom);
    return;
   }
  if(!user->internal) deluser(user); else
   {
    senduser(upFD, user);
    context;
    info.joins++;
    if(user->internal==1)
     {
      usernotice(who, "Ehm.. who is trying to kill me ???");
      killl(NULL, who, "Ehm.. who is trying to kill me ???");
     }
    if(user->internal==2)
      usernotice(who, "Use services to remove jupitered nick.");
//    if(user->internal==3)
//      usernotice(who, "Virtual network user can be removed only on remote network.");
//    if(user->internal==4)
//      usernotice(who, "Use services to remove clones.");
   }
 }

void hh_ping(void)
 {
  context;
  if(who)
    sockprintf(upFD, ":%s PONG %s :%s\n", arg[0], arg[0], whom); else
  if(args==-1)
    sockprintf(upFD, ":%s PONG %s :%s\n", config.name, config.name, whom); else
    sockprintf(upFD, ":%s PONG %s :%s\n", arg[0], arg[0], whom);
 }

void hh_version(void)
 {
  context;
  sockprintf(upFD, ":%s 351 %s 2.8/ircdserv-%s. %s :ACJMNO TS3ow\n", config.name, who, VERSION, config.name);
 }

void hh_admin(void)
 {
  context;
  sockprintf(upFD, ":%s 256 %s :Administrative info about services %s\n", config.name, who, config.name);
  sockprintf(upFD, ":%s 257 %s :%s\n", config.name, who, config.admin[0]);
  sockprintf(upFD, ":%s 258 %s :%s\n", config.name, who, config.admin[1]);
  sockprintf(upFD, ":%s 259 %s :%s\n", config.name, who, config.admin[2]);
 }

void hh_quit(void)
 {
  context;
  deluser(finduser(who));
 }

void hh_nick(void)
 {
  TUser *user;
  
  context;
  if(who)
   {
    user=finduser(who);
    if(!user)
     {
      logit("HH_NICK: No such nick %s.\n", who);
      fatal(3);
     }
    if(user->next) user->next->prev=user->prev;
    if(user->prev) user->prev->next=user->next;
     else users->hashtable[hashuser(user->nick)]=user->next;
    strcpy(user->nick, whom);
    context;
    user->next=users->hashtable[hashuser(user->nick)];
    users->hashtable[hashuser(user->nick)]=user;
    info.nickchngs++;
   } else
   {
    context;
    lineargs(6);
    adduser(whom, arg[3], arg[4], arg[5], atoi(arg[1]), atoi(arg[0]), !(!strchr(arg[2], 'o')), !(!strchr(arg[2], 'i')), 0, "%s", ++arg[6]);
   }
 }

void hh_server(void)
 {
  context;
  lineargs(1);
  if(arg[1][0]==':') arg[1]++;
  if(!who) addserver(whom, arg[1], atoi(arg[0]), 0, config.name); else
           addserver(whom, arg[1], atoi(arg[0]), 0, who);
 }

void hh_pass(void)
 {
  context;
  if(strcmp(whom, info.linkserver->pass))
   breaklink("Bad Password");
  if(!arg[0] || strcmp(arg[0], "TS"))
   breaklink("Non-TS server");
 }

void hh_capab(void)
 {
  int i;
  
  context;
  info.linkcapab|=checkcapab(whom);
  for(i=0; arg[i]; i++) info.linkcapab|=checkcapab(arg[i]);
  context;
 }

void hh_svinfo(void)
 {
  context;
  if(TS_CURRENT<atoi(arg[0]) || atoi(whom)<TS_MIN)
   breaklink("Incompatible TS version");
  if(abs(time(NULL)-atoi(arg[2]+1))>TS_MAX_DELTA)
   breaklink("Excessive TS delta");
 }

void hh_squit(void)
 {
  TServer *server, *serv;
  
  context;
  server=findserver(whom);
  if(!server)
   {
    logit("HH_SQUIT: No such server - %s.\n", whom);
    return;
   }
  if(server->internal)
   {
    for(serv=servers; serv; serv=serv->next) serv->temp=0;
    server->temp=1;
    for(serv=servers; serv; serv=serv->next)
     {
      if(serv->uplink && serv->uplink->temp) serv->temp=1;
      if(serv->temp) sendserver(upFD, serv);
     }
    context;
    if(server->internal==1)
     {
      logit("HH_SQUIT: Somebody SQUITed me and i can see that !!! WTF ircd is my uplink ???\n");
      fatal(2);
     }
    if(server->internal==2)
      usernotice(who, "Use services to remove jupitered server.");
//    if(server->internal==3)
//      usernotice(who, "Virtual network user can be removed only on remote network.");
    
   } else delserver(server);
 }

void hh_trace(void)
 {
  TUser *user;
  
  context;
  user=finduser(whom);
  if(user && user->internal)
   sockprintf(upFD, ":%s 204 %s Oper 0 %s[%s@%s] (127.0.0.1) 000000000 000000000\n", config.name, who, whom, whom, config.name); else
   sockprintf(upFD, ":%s 206 %s Serv 0 0S 0C %s[%s@%s] AutoConn.!*@%s :0\n", config.name, who, config.name, config.name, config.name);
  sockprintf(upFD, ":%s 262 %s %s :End of TRACE\n", config.name, who, whom);
 }

void hh_mode(void)
 {
  TUser *user;
  int plus, pos;
  
  context;
  user=finduser(whom);
  if(user) // it's a user...
   {
    plus=1; pos=0;
    while(arg[0][pos])
     {
      switch(arg[0][pos])
       {
        case '+': { plus=1; break; }
        case '-': { plus=0; break; }
        case 'i': 
         {
          if(user->invisible && !plus) users->invisible--;
          context;
          if(!user->invisible && plus) users->invisible++;
          user->invisible=plus;
          break;
         }
        case 'o':
         {
          context;
          if(user->ircop && !plus) users->ircop--;
          if(!user->ircop && plus) users->ircop++;
          user->ircop=plus;
          break;
         }
       }
      pos++;
     }
   } else
  if(strchr(whom, '#'))
   setmode(findchannel(whom), arg[0], 1);
  else
   {
    logit("HH_MODE: What the hell is this - %s ?\n", whom);
    fatal(2);
   }
 }

void hh_sjoin(void)
 {
  TChannel *chan;
  TNickList *nlist;
  int i, op, vop;

  context;
  chan=findchannel(arg[0]);
  if(chan)
   {
    if(chan->ts>atoi(whom))
     {
      for(nlist=chan->nicklist; nlist; nlist=nlist->next)
       nlist->op=nlist->vop=0;
      chan->ts=atoi(whom);
      chan->inviteo=chan->userlimit=chan->moderated=chan->nomsg=chan->private=chan->secure=chan->topicopo=0;
       // remove all bans here
     }
   } else chan=addchannel(arg[0], atoi(whom));
  context;
  i=setmode(chan, arg[1], 2);
  if(arg[i][0]==':') arg[i]++;
  while(arg[i])
   {
    op=vop=0;
    while((arg[i][0]=='+') || (arg[i][0]=='@'))
     {
      if(arg[i][0]=='+') vop=1;
      if(arg[i][0]=='@') op=1;
      arg[i]++;
     }
    addchanuser(chan, finduser(arg[i]), op, vop);
    i++;
   }
 }

void hh_part(void)
 {
  context;
  delchanuser(findchannel(whom), finduser(who));
  context;
 }

void hh_kick(void)
 {
  context;
  delchanuser(findchannel(whom), finduser(arg[0]));
  context;
 }

void hh_topic(void)
 {
  TChannel *chan;
  
  context;
  lineargs(0);
  if(!(chan=findchannel(whom)))
   logit("HH_TOPIC: No such channel %s.", whom); else
   strcpy(chan->topic, arg[0]);
 }

TCmdInput inputcmds[] = {
{ "PRIVMSG",	hh_privmsg },
{ "NOTICE",	hh_notice },
{ "PING",	hh_ping },
{ "KILL",	hh_kill },
{ "VERSION",	hh_version },
{ "STATS",	hh_stats },
{ "ADMIN",	hh_admin },
{ "QUIT",	hh_quit },
{ "NICK",	hh_nick },
{ "SERVER",	hh_server },
{ "PASS",	hh_pass },
{ "CAPAB",	hh_capab },
{ "SVINFO",	hh_svinfo },
{ "SQUIT",	hh_squit },
{ "TRACE",	hh_trace },
{ "MODE",	hh_mode },
{ "SJOIN",	hh_sjoin },
{ "PART",	hh_part },
{ "KICK",	hh_kick },
{ "TOPIC",	hh_topic },
{ NULL,		NULL, }
};

void hh_parse(char *cmd)
 {
  int i=0, j=1;
  while(inputcmds[i].cmd)
   {
    if(!strcasecmp(cmd, inputcmds[i].cmd))
     {
      inputcmds[i].handler();
      j=0;
      break;
     }
    i++;
   }
  if(j) logit("Unknown command - %s %s\n", cmd, arg[0]);
 }
