/***********************************************************************
 *   IRCDSERV - Internet Relay Chat Services                            *
 *   Copyright (C) 1999-2000 Jan Oravec(WSX) and Juraj Lutter(otis)     *
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 1,    *
 *   or (at your option) any later version.                             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 *   You should have received a copy of the GNU General Public License  *
 *   along with this program; if not, write to the Free Software        *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.          *
  ***********************************************************************/
#include "ircdserv.h"

int spfrunning=0; // semafor for sockprintf

void sockprintf(int FD, char *format, ...)
 {
  char buffer[1024];
  va_list va;
  context;
  while(spfrunning);
  spfrunning=1;
  va_start(va, format);
  vsprintf(buffer, format, va);
  va_end(va);
  context;
  printf("OUTPUT: %s", buffer);
  secure_send_string(FD, buffer);
  spfrunning=0;
  context;
 }

void breaklink(char *s)
 {
  context;
  sockprintf(upFD, "Error :Closing link: %s (%s)\n", info.linkserver->host, s);
  logit("BREAKLINK: Closing link: %s (%s)\n", info.linkserver->host, s);
  disconnect=1;
  context;
 }

void sendserver(int FD, TServer *serv)
 {
  context;
  if(serv->uplink)
    sockprintf(FD, ":%s SERVER %s %i :%s\n", serv->uplink->name, serv->name, serv->hops+1, serv->desc);
   else
    sockprintf(FD, "SERVER %s %i :%s\n", serv->name, serv->hops+1, serv->desc);
// I should make wildcarding here...
 }

void senduser(int FD, TUser *user)
 {
  char buff[10];
  context;
  buff[0]=0;
  if(user->ircop) strcpy(buff+strlen(buff), "o");
  if(user->invisible) strcpy(buff+strlen(buff), "i");
  sockprintf(upFD, "NICK %s %d %d +%s %s %s %s :%s\n",
    user->nick, user->hops+1, user->ts, buff, user->user,
    user->host, user->serv->name, user->name);
 }

int connectto(TConn *serv)
 {
  int i;
  TServer *server;
  TUser *user;
  char c[1024];

  context;
  upFD=open_sock();
  logit("CONNECTTO: Link to server %s(%s:%d)...\n", serv->name, serv->host, serv->port);
  if(bind_sock(upFD, serv->host, serv->port, 0)==-1)
   {
    logit("CONNECTTO: Connect failed...\n");
    close_sock(upFD);
    return 1;
   }
  logit("CONNECTTO: Connected to %s...\n", serv->name);
  info.linkserver=serv;
  info.linkcapab=disconnect=0;
  sockprintf(upFD, "PASS %s :TS\n", serv->pass);
  sockprintf(upFD, "CAPAB :%s\n", mycapab(c));
  context;
  server=servers;
  while(server)
   {
    sendserver(upFD, server);
    server=server->next;
   }
  sockprintf(upFD, "SVINFO %i %i 1 :%i\n", TS_CURRENT, TS_MIN, time(NULL));
  for(i=0; i!=ESTUSERS; i++)
   {
    user=users->hashtable[i];
    while(user)
     {
      senduser(upFD, user);
      user=user->next;
     }
   }
  context;
  return 0;
 }
