/***********************************************************************
 *   IRCDSERV - Internet Relay Chat Services                            *
 *   Copyright (C) 1999-2000 Jan Oravec(WSX) and Juraj Lutter(otis)     *
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 1,    *
 *   or (at your option) any later version.                             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 *   You should have received a copy of the GNU General Public License  *
 *   along with this program; if not, write to the Free Software        *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.          *
  ***********************************************************************/
#include "ircdserv.h"

char salt_chars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";

char *pcrypt(char *text)
 {
  char salt[8];

  context;
  srandom(time(NULL));
  salt[0]=salt_chars[random() % 64];
  salt[1]=salt_chars[random() % 64];
  salt[2]=0;
#ifdef MD5_CRYPT
  salt[2]=salt_chars[random() % 64];
  salt[3]=salt_chars[random() % 64];
  salt[4]=salt_chars[random() % 64];
  salt[5]=salt_chars[random() % 64];
  salt[6]=salt_chars[random() % 64];
  salt[7]=salt_chars[random() % 64];
  salt[8]=0;
#endif // MD5_CRYPT
  context;
  return crypt(text, salt);
 }

int passcheck(char *pass, char *crypted)
 {
  char salt[8];

  context;
#ifdef MD5_CRYPT
  strlcpy(salt, &crypted[3], sizeof(salt));
  salt[8]=0;
#else
  salt[0]=crypted[0];
  salt[1]=crypted[1];
  salt[2]=0;
#endif // MD5_CRYPT
  context;
  return !strcmp(crypted, crypt(pass, salt));
 }
 