/***********************************************************************
 *   IRCDSERV - Internet Relay Chat Services                            *
 *   Copyright (C) 1999-2000 Jan Oravec(WSX) and Juraj Lutter(otis)     *
 *                                                                      *
 *   This program is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License        *
 *   as published by the Free Software Foundation; either version 1,    *
 *   or (at your option) any later version.                             *
 *                                                                      *
 *   This program is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                       *
 *                                                                      *
 *   You should have received a copy of the GNU General Public License  *
 *   along with this program; if not, write to the Free Software        *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.          *
  ***********************************************************************/
/* prevadzka serioveho portu po IP kanali
 *
 * ss_sock.h
 */

#ifndef __SS_SOCK_H
#define __SS_SOCK_H

#include <stdio.h>
#include <errno.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <syslog.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <signal.h>

#define SOCK_LISTEN 1

/* po kolkych milisekundach ma nastat timeout ?
 */
extern int sock_timeout;

int init_sock( void );
int done_sock( void );

int open_sock( void );
int bind_sock( int fd, char * addr, int port, int __listen );

int connect_sock_ip( int fd, struct in_addr* adresa, int port );
int connect_sock_hostname( int fd, char* hostname, int port );

int close_sock( int fd );

int secure_write( int fd, void * buff, size_t size );
int secure_read( int fd, void * buff, size_t size );
int secure_send_string( int fd, char * str );


int timeout_read( int fd, int secs, int msecs );
int timeout_write( int fd, int secs, int msecs );

#endif
